diff --git a/src/main/java/net/minecraft/client/gui/GuiMainMenu.java b/src/main/java/net/minecraft/client/gui/MainMenuScreen.java
similarity index 74%
rename from src/main/java/net/minecraft/client/gui/GuiMainMenu.java
rename to src/main/java/net/minecraft/client/gui/MainMenuScreen.java
index 00d4ac2b6..c6b61ee89 100644
--- a/src/main/java/net/minecraft/client/gui/GuiMainMenu.java
+++ b/src/main/java/net/minecraft/client/gui/MainMenuScreen.java
@@ -15,6 +15,9 @@ import java.util.Random;
 
 import javax.imageio.ImageIO;
 
+import com.mojang.logging.LogUtils;
+import net.minecraft.client.gui.hud.IngameHud;
+import net.minecraft.client.gui.hud.DoomIngameHud;
 import net.minecraft.client.render.block.model.BlockModelDispatcher;
 import net.minecraft.client.render.texture.stitcher.TextureRegistry;
 import net.minecraft.client.render.tessellator.Tessellator;
@@ -24,7 +27,7 @@ import org.lwjgl.opengl.GL11;
 import org.lwjgl.util.glu.GLU;
 
 import net.minecraft.client.Minecraft;
-import net.minecraft.client.gui.options.GuiOptions;
+import net.minecraft.client.gui.options.OptionsScreen;
 import net.minecraft.client.gui.options.data.OptionsPages;
 import net.minecraft.client.render.RenderBlocks;
 import net.minecraft.core.block.Block;
@@ -32,9 +35,11 @@ import net.minecraft.core.block.Blocks;
 import net.minecraft.core.lang.I18n;
 import net.minecraft.core.sound.SoundCategory;
 import net.minecraft.core.util.helper.MathHelper;
+import org.slf4j.Logger;
 
-public class GuiMainMenu extends GuiScreen
+public class MainMenuScreen extends Screen
 {
+    private static final Logger LOGGER = LogUtils.getLogger();
 
     private static final Block[] BLOCKS_TO_DRAW = {
     		Blocks.STONE, Blocks.DIRT, Blocks.PLANKS_OAK, Blocks.COBBLE_STONE, Blocks.COBBLE_STONE_MOSSY, Blocks.BASALT, Blocks.LIMESTONE,
@@ -50,7 +55,7 @@ public class GuiMainMenu extends GuiScreen
     private static final Random rand = new Random();
     
     private String splashText = "missingno";
-    private GuiButton multiplayerButton;
+    private ButtonElement multiplayerButton;
     private LogoBlock[][] logoBlocks;
     private int logoClickCounter = 0;
     private int indexToDraw = 0;
@@ -61,51 +66,49 @@ public class GuiMainMenu extends GuiScreen
     	loadLogo();
     }
 
-	public GuiMainMenu() {
-		GuiIngameMenu.photoModeDisabled = false;
-
-		InputStream stream = null;
-		try {
-			stream = GuiMainMenu.class.getResourceAsStream("/assets/minecraft/textures/gui/title/splashes.txt");
-
-			List<String> allSplashes = new ArrayList<>();
-			BufferedReader br = new BufferedReader(new InputStreamReader(stream, StandardCharsets.UTF_8));
-
-			while(true) {
-				String line = br.readLine();
-				if(line == null) {
-					break;
-				}
-				line = line.trim();
-				if(!line.isEmpty()) {
-					allSplashes.add(line);
-				}
-			}
-			splashText = allSplashes.get(rand.nextInt(allSplashes.size()));
-		}catch (Exception e) {
-
-		}finally {
-			try {
-				stream.close();
-			}catch (Exception e) {}
-		}
+	public MainMenuScreen() {
+		PauseScreen.photoModeDisabled = false;
+
+        try (InputStream stream = MainMenuScreen.class.getResourceAsStream("/assets/minecraft/textures/gui/title/splashes.txt")) {
+
+            if (stream == null) {
+                LOGGER.error("Could not locate 'splashes.txt'! Does the file exist!?");
+                return;
+            }
+            List<String> allSplashes = new ArrayList<>();
+            BufferedReader br = new BufferedReader(new InputStreamReader(stream, StandardCharsets.UTF_8));
+
+            while (true) {
+                String line = br.readLine();
+                if (line == null) {
+                    break;
+                }
+                line = line.trim();
+                if (!line.isEmpty()) {
+                    allSplashes.add(line);
+                }
+            }
+            splashText = allSplashes.get(rand.nextInt(allSplashes.size()));
+        } catch (Exception e) {
+            LOGGER.error("Failed to load splash texts!", e);
+        }
 	}
 
     @Override
-	public void keyTyped(char c, int i, int mouseX, int mouseY)
+	public void keyPressed(char eventCharacter, int eventKey, int mx, int my)
     {
-        if (i == KEY_CHAIN[codeProgress])
+        if (eventKey == KEY_CHAIN[codeProgress])
         {
             codeProgress++;
             if (codeProgress == KEY_CHAIN.length)
             {
-                if (mc.ingameGUI instanceof GuiIngameDoom)
+                if (mc.ingameHud instanceof DoomIngameHud)
                 {
-                    mc.ingameGUI = new GuiIngame(mc);
+                    mc.ingameHud = new IngameHud(mc);
                 }
                 else
                 {
-                    mc.ingameGUI = new GuiIngameDoom(mc);
+                    mc.ingameHud = new DoomIngameHud(mc);
                 }
                 mc.sndManager.playSound("mob.pig", SoundCategory.GUI_SOUNDS, 1.0F, 1.0F);
                 codeProgress = 0;
@@ -154,27 +157,27 @@ public class GuiMainMenu extends GuiScreen
         }
 
         int i = height / 4 + 48;
-        controlList.add(new GuiButton(1, width / 2 - 100, i, i18n.translateKey("gui.main_menu.button.singleplayer")));
-        controlList.add(multiplayerButton = new GuiButton(2, width / 2 - 100, i + 24, i18n.translateKey("gui.main_menu.button.multiplayer")));
-        controlList.add(new GuiButton(3, width / 2 - 100, i + 48, i18n.translateKey("gui.main_menu.button.texture_packs")));
+        buttons.add(new ButtonElement(1, width / 2 - 100, i, i18n.translateKey("gui.main_menu.button.singleplayer")));
+        buttons.add(multiplayerButton = new ButtonElement(2, width / 2 - 100, i + 24, i18n.translateKey("gui.main_menu.button.multiplayer")));
+        buttons.add(new ButtonElement(3, width / 2 - 100, i + 48, i18n.translateKey("gui.main_menu.button.texture_packs")));
         if(mc.hideQuitButton)
         {
-            controlList.add(new GuiButton(0, width / 2 - 100, i + 72, i18n.translateKey("gui.main_menu.button.options")));
+            buttons.add(new ButtonElement(0, width / 2 - 100, i + 72, i18n.translateKey("gui.main_menu.button.options")));
         } else
         {
-            controlList.add(new GuiButton(0, width / 2 - 100, i + 72 + 12, 98, 20, i18n.translateKey("gui.main_menu.button.options")));
-            controlList.add(new GuiButton(4, width / 2 + 2, i + 72 + 12, 98, 20, i18n.translateKey("gui.main_menu.button.quit_game")));
+            buttons.add(new ButtonElement(0, width / 2 - 100, i + 72 + 12, 98, 20, i18n.translateKey("gui.main_menu.button.options")));
+            buttons.add(new ButtonElement(4, width / 2 + 2, i + 72 + 12, 98, 20, i18n.translateKey("gui.main_menu.button.quit_game")));
         }
         int d = 1; // Move away from the edge of the screen to prevent unintentional activation because the cursor defaults to 0, 0
-        controlList.add(new GuiClickableLabel(5, d, height - 48 - d, i18n.translateKey("gui.main_menu.button.credits"), 0x9F9F9F));
-        controlList.add(new GuiClickableLabel(6, d, height - 36 - d, i18n.translateKey("gui.main_menu.button.website"), 0x5AA938));
-        controlList.add(new GuiClickableLabel(7, d, height - 24 - d, i18n.translateKey("gui.main_menu.button.discord"), 0x5865F2));
-        controlList.add(new GuiClickableLabel(8, d, height - 12 - d, i18n.translateKey("gui.main_menu.button.youtube"), 0xFF0000));
-        controlList.add(new GuiButton(9, width / 2 + 104, i + 72 + 12, 20, 20, "")
+        buttons.add(new ClickableLabelElement(5, d, height - 48 - d, i18n.translateKey("gui.main_menu.button.credits"), 0x9F9F9F));
+        buttons.add(new ClickableLabelElement(6, d, height - 36 - d, i18n.translateKey("gui.main_menu.button.website"), 0x5AA938));
+        buttons.add(new ClickableLabelElement(7, d, height - 24 - d, i18n.translateKey("gui.main_menu.button.discord"), 0x5865F2));
+        buttons.add(new ClickableLabelElement(8, d, height - 12 - d, i18n.translateKey("gui.main_menu.button.youtube"), 0xFF0000));
+        buttons.add(new ButtonElement(9, width / 2 + 104, i + 72 + 12, 20, 20, "")
             .setTextures("minecraft:gui/misc/button_language", "minecraft:gui/misc/button_language_highlighted", "minecraft:gui/misc/button_language"));
-        GuiButton debugButton = new GuiButton(10, width - 8, height - 8, 8, 8, "");
+        ButtonElement debugButton = new ButtonElement(10, width - 8, height - 8, 8, 8, "");
         debugButton.visible = false;
-        controlList.add(debugButton);
+        buttons.add(debugButton);
         if(mc.session == null)
         {
             multiplayerButton.enabled = false;
@@ -187,23 +190,23 @@ public class GuiMainMenu extends GuiScreen
     }
 
     @Override
-    protected void buttonPressed(GuiButton button)
+    protected void buttonClicked(ButtonElement button)
     {
         if(button.id == 0)
         {
-            mc.displayGuiScreen(new GuiOptions(this));
+            mc.displayScreen(new OptionsScreen(this));
         }
         if(button.id == 1)
         {
-            mc.displayGuiScreen(new GuiSelectWorld(this));
+            mc.displayScreen(new SelectWorldScreen(this));
         }
         if(button.id == 2)
         {
-            mc.displayGuiScreen(new GuiSelectServer(this));
+            mc.displayScreen(new SelectServerScreen(this));
         }
         if(button.id == 3)
         {
-            mc.displayGuiScreen(new GuiOptions(this, OptionsPages.TEXTURE_PACKS));
+            mc.displayScreen(new OptionsScreen(this, OptionsPages.TEXTURE_PACKS));
         }
         if(button.id == 4)
         {
@@ -211,14 +214,14 @@ public class GuiMainMenu extends GuiScreen
         }
         if(button.id == 5)
         {
-            mc.displayGuiScreen(new GuiCredits(this));
+            mc.displayScreen(new CreditsScreen(this));
         }
         if(button.id == 9)
         {
-            mc.displayGuiScreen(new GuiOptions(this, OptionsPages.LANGUAGE));
+            mc.displayScreen(new OptionsScreen(this, OptionsPages.LANGUAGE));
         }
         if(button.id == 10){
-            mc.displayGuiScreen(new GuiOptions(this, OptionsPages.DEBUG));
+            mc.displayScreen(new OptionsScreen(this, OptionsPages.DEBUG));
         }
         Desktop desktop = Desktop.isDesktopSupported() ? Desktop.getDesktop() : null;
         if (desktop != null && desktop.isSupported(Desktop.Action.BROWSE))
@@ -230,7 +233,7 @@ public class GuiMainMenu extends GuiScreen
                     desktop.browse(URI.create("https://betterthanadventure.net"));
                 } catch (Exception e)
                 {
-                    e.printStackTrace();
+                    LOGGER.error("Exception occurred when attempting to open URL 'https://betterthanadventure.net'!", e);
                 }
             }
             if (button.id == 7) // Discord
@@ -240,7 +243,7 @@ public class GuiMainMenu extends GuiScreen
                     desktop.browse(URI.create("https://betterthanadventure.net/discord"));
                 } catch (Exception e)
                 {
-                    e.printStackTrace();
+                    LOGGER.error("Exception occurred when attempting to open URL 'https://betterthanadventure.net/discord'!", e);
                 }
             }
             if (button.id == 8) // YouTube
@@ -250,18 +253,18 @@ public class GuiMainMenu extends GuiScreen
                     desktop.browse(URI.create("https://www.youtube.com/channel/UC_GT4t8Io87-UTzaGNnsuMg"));
                 } catch (Exception e)
                 {
-                    e.printStackTrace();
+                    LOGGER.error("Exception occurred when attempting to open URL 'https://www.youtube.com/channel/UC_GT4t8Io87-UTzaGNnsuMg'!", e);
                 }
             }
         }
     }
 
 	@Override
-	public void drawBackground() {
+	public void renderTexturedBackground() {
 		if(mc.mainMenuBackground.isEnabled() && !mc.gameSettings.alphaMenu.value) {
 			mc.mainMenuBackground.draw();
 		}else {
-			super.drawBackground();
+			super.renderTexturedBackground();
 		}
 	}
 
@@ -270,11 +273,9 @@ public class GuiMainMenu extends GuiScreen
     {
         if(this.logoBlocks != null)
         {
-            for(int var1 = 0; var1 < this.logoBlocks.length; ++var1)
-            {
-                for(int var2 = 0; var2 < this.logoBlocks[var1].length; ++var2)
-                {
-                    this.logoBlocks[var1][var2].updateLogoEffects();
+            for (LogoBlock[] logoBlock : this.logoBlocks) {
+                for (LogoBlock block : logoBlock) {
+                    block.updateLogoEffects();
                 }
             }
         }
@@ -282,15 +283,15 @@ public class GuiMainMenu extends GuiScreen
     }
 
     @Override
-    public void mouseClicked(int mouseX, int mouseY, int mouseButton)
+    public void mouseClicked(int mx, int my, int buttonNum)
     {
-        super.mouseClicked(mouseX, mouseY, mouseButton);
+        super.mouseClicked(mx, my, buttonNum);
 
-        int logoWidth = '\u0112';
+        int logoWidth = 274;
         int logoX = width / 2 - logoWidth / 2;
         int logoHeight = 30;
         int p = 8;
-        if (mouseX >= logoX + p && mouseX <= logoX + 270 - p && mouseY >= logoHeight + p && mouseY <= logoHeight + 48 - p)
+        if (mx >= logoX + p && mx <= logoX + 270 - p && my >= logoHeight + p && my <= logoHeight + 48 - p)
         {
             if (logoClickCounter >= 0)
             {
@@ -304,9 +305,9 @@ public class GuiMainMenu extends GuiScreen
                 logoClickCounter++;
             }
         }
-        if (mouseY >= 2 && mouseY <= 12)
+        if (my >= 2 && my <= 12)
         {
-            if (mouseX >= 2 && mouseX <= 40)
+            if (mx >= 2 && mx <= 40)
             {
                 showBuildTime = !showBuildTime;
             }
@@ -314,18 +315,18 @@ public class GuiMainMenu extends GuiScreen
     }
 
     @Override
-    public void drawScreen(int mouseX, int mouseY, float partialTick)
+    public void render(int xm, int ym, float partialTick)
     {
         I18n i18n = I18n.getInstance();
-        drawDefaultBackground();
-        char c = '\u0112';
+        renderBackground();
+        int c = 274;
         int k = width / 2 - c / 2;
         byte byte0 = 30;
         if (!mc.gameSettings.alphaMenu.value)
         {
-            mc.renderEngine.loadTexture("/assets/minecraft/textures/gui/title/mclogo.png").bind();
+            mc.textureManager.loadTexture("/assets/minecraft/textures/gui/title/mclogo.png").bind();
             GL11.glColor4f(1.0F, 1.0F, 1.0F, 1.0F);
-            drawTexturedModalRect(k + 0, byte0 + 0, 0, 0, 274, 50, 1d/274, 1d/50);
+            drawTexturedModalRect(k, byte0, 0, 0, 274, 50, 1d/274, 1d/50);
         }
         else
         {
@@ -335,28 +336,28 @@ public class GuiMainMenu extends GuiScreen
         GL11.glTranslatef(width / 2 + 140, 80F, 0.0F);
         GL11.glRotatef(-20F, 0.0F, 0.0F, 1.0F);
         float f1 = 1.8F - MathHelper.abs(MathHelper.sin(((float)(System.currentTimeMillis() % 1000L) / 1000F) * MathHelper.PI * 2.0F) * 0.1F);
-        f1 = (f1 * 100F) / (float)(fontRenderer.getStringWidth(splashText) + 32);
+        f1 = (f1 * 100F) / (float)(font.getStringWidth(splashText) + 32);
         GL11.glScalef(f1, f1, f1);
-        drawStringCentered(fontRenderer, splashText, 0, -8, 0xffff00);
+        drawStringCentered(font, splashText, 0, -8, 0xffff00);
         GL11.glPopMatrix();
         int versionTextColor = mc.gameSettings.alphaMenu.value || !mc.mainMenuBackground.isEnabled() ? 0x505050 : 0xFFFFFF;
         if (showBuildTime) {
-            drawString(fontRenderer, Global.BUILD_TIME, 2, 2, versionTextColor);
+            drawString(font, Global.BUILD_TIME, 2, 2, versionTextColor);
         } else {
-            drawString(fontRenderer, "Better than Adventure! " + Minecraft.VERSION, 2, 2, versionTextColor);
+            drawString(font, "Better than Adventure! " + Minecraft.VERSION, 2, 2, versionTextColor);
         }
         String disclaimer1 = i18n.translateKey("gui.main_menu.label.disclaimer.1");
-        drawString(fontRenderer, disclaimer1, width - fontRenderer.getStringWidth(disclaimer1) - 2, height - 20, 0xffffff);
+        drawString(font, disclaimer1, width - font.getStringWidth(disclaimer1) - 2, height - 20, 0xffffff);
         String disclaimer2 = i18n.translateKey("gui.main_menu.label.disclaimer.2");
-        drawString(fontRenderer, disclaimer2, width - fontRenderer.getStringWidth(disclaimer2) - 2, height - 10, 0xffffff);
-        super.drawScreen(mouseX, mouseY, partialTick);
+        drawString(font, disclaimer2, width - font.getStringWidth(disclaimer2) - 2, height - 10, 0xffffff);
+        super.render(xm, ym, partialTick);
         
     	if(mc.downloadResourcesThread.downloading) {
     		double b = java.lang.Math.sin((System.currentTimeMillis() / 1000.0) * 4);
     		b = b * 0.2 + 0.8;
     		int ib = (int) java.lang.Math.round(b * 255);
     		int color = 0xFF000000 + (ib << 16) + (ib << 8) + (ib);
-    		mc.fontRenderer.drawCenteredString(
+    		mc.font.drawCenteredString(
                 i18n.translateKeyAndFormat("gui.main_menu.label.downloading_resources", mc.downloadResourcesThread.downloadProgress.get(), mc.downloadResourcesThread.toDownload),
                 width / 2, 16, color);
     	}
@@ -415,7 +416,7 @@ public class GuiMainMenu extends GuiScreen
             GL11.glTranslatef((float)(-logoBlockLayers[0].length()) * 0.5F, (float)(-logoBlockLayers.length) * 0.5F, 0.0F);
             TextureRegistry.blockAtlas.bind();
             if(var4 == 0) {
-                this.mc.renderEngine.loadTexture("/title/black.png").bind();
+                this.mc.textureManager.loadTexture("/title/black.png").bind();
             }
 
             RenderBlocks var5 = new RenderBlocks();
@@ -462,10 +463,10 @@ public class GuiMainMenu extends GuiScreen
     
     public static void loadLogo() {
     	try {
-    		InputStream inputStream = GuiMainMenu.class.getResourceAsStream("/assets/minecraft/textures/gui/title/retrologo.png");
+    		InputStream inputStream = MainMenuScreen.class.getResourceAsStream("/assets/minecraft/textures/gui/title/retrologo.png");
     		BufferedImage image = ImageIO.read(inputStream);
     		inputStream.close();
-    		
+
     		logoBlockLayers = new String[image.getHeight()];
     		
     		for(int i=0; i < image.getHeight(); i++) {
@@ -484,11 +485,11 @@ public class GuiMainMenu extends GuiScreen
     			logoBlockLayers[i] = builder.toString();
     		}
     	}catch (Exception e) {
-    		e.printStackTrace();
+            LOGGER.error("Exception while loading retro logo!", e);
 		}
     }
     
-    class LogoBlock {
+    static class LogoBlock {
     	
         public double height;
         public double prevHeight;
diff --git a/src/main/java/net/minecraft/client/gui/GuiMissingMinecraft.java b/src/main/java/net/minecraft/client/gui/MissingMinecraftScreen.java
similarity index 60%
rename from src/main/java/net/minecraft/client/gui/GuiMissingMinecraft.java
rename to src/main/java/net/minecraft/client/gui/MissingMinecraftScreen.java
index 8d649f6ea..4efb5c71e 100644
--- a/src/main/java/net/minecraft/client/gui/GuiMissingMinecraft.java
+++ b/src/main/java/net/minecraft/client/gui/MissingMinecraftScreen.java
@@ -1,41 +1,44 @@
 package net.minecraft.client.gui;
 
+import com.mojang.logging.LogUtils;
 import net.minecraft.client.render.tessellator.Tessellator;
 import net.minecraft.core.lang.I18n;
 import net.minecraft.core.util.helper.MathHelper;
 import org.lwjgl.opengl.GL11;
+import org.slf4j.Logger;
 
 import java.awt.*;
 import java.net.URI;
 
-public class GuiMissingMinecraft extends GuiScreen{
+public class MissingMinecraftScreen extends Screen {
+    private static final Logger LOGGER = LogUtils.getLogger();
     public int ticks = 0;
     @Override
     public void init()
     {
         I18n i = I18n.getInstance();
-        controlList.clear();
+        buttons.clear();
         String downloadString = i.translateKey("gui.no_minecraft.button.guide");
-        controlList.add(new GuiButton(0, width / 2 - 100, height / 4 + 120 + 12, i.translateKey("gui.no_minecraft.button.quit")));
-        GuiClickableLabel installLabel = new GuiClickableLabel(1, width / 2 - 170, (height / 4 - 60) + 60 + 64, downloadString, 0x7C99EA);
-        controlList.add(installLabel);
-        controlList.add(new GuiClickableLabel(2, 0,  height - fontRenderer.fontHeight - 4, i.translateKey("gui.main_menu.button.discord"), 0x5865F2));
+        buttons.add(new ButtonElement(0, width / 2 - 100, height / 4 + 120 + 12, i.translateKey("gui.no_minecraft.button.quit")));
+        ClickableLabelElement installLabel = new ClickableLabelElement(1, width / 2 - 170, (height / 4 - 60) + 60 + 64, downloadString, 0x7C99EA);
+        buttons.add(installLabel);
+        buttons.add(new ClickableLabelElement(2, 0,  height - font.fontHeight - 4, i.translateKey("gui.main_menu.button.discord"), 0x5865F2));
     }
     @Override
-    public void drawScreen(int mouseX, int mouseY, float partialTick)
+    public void render(int xm, int ym, float partialTick)
     {
         I18n i = I18n.getInstance();
         drawBackground(partialTick);
-        drawStringCentered(fontRenderer, i.translateKey("gui.no_minecraft.label.title"), width / 2, (height / 4 - 60) + 20, 0xffff60);
-        drawString(fontRenderer, i.translateKey("gui.no_minecraft.label.body.1"), width / 2 - 170, (height / 4 - 60) + 60 + 0, 0xdedede);
-        drawString(fontRenderer, i.translateKey("gui.no_minecraft.label.body.2"), width / 2 - 170, (height / 4 - 60) + 60 + 18, 0xdedede);
-        drawString(fontRenderer, i.translateKey("gui.no_minecraft.label.body.3"), width / 2 - 170, (height / 4 - 60) + 60 + 27, 0xdedede);
-        drawString(fontRenderer, i.translateKey("gui.no_minecraft.label.body.4"), width / 2 - 170, (height / 4 - 60) + 60 + 45, 0xdedede);
-        drawString(fontRenderer, i.translateKey("gui.no_minecraft.label.body.5"), width / 2 - 170, (height / 4 - 60) + 60 + 54, 0xdedede);
-        super.drawScreen(mouseX, mouseY, partialTick);
+        drawStringCentered(font, i.translateKey("gui.no_minecraft.label.title"), width / 2, (height / 4 - 60) + 20, 0xffff60);
+        drawString(font, i.translateKey("gui.no_minecraft.label.body.1"), width / 2 - 170, (height / 4 - 60) + 60 + 0, 0xdedede);
+        drawString(font, i.translateKey("gui.no_minecraft.label.body.2"), width / 2 - 170, (height / 4 - 60) + 60 + 18, 0xdedede);
+        drawString(font, i.translateKey("gui.no_minecraft.label.body.3"), width / 2 - 170, (height / 4 - 60) + 60 + 27, 0xdedede);
+        drawString(font, i.translateKey("gui.no_minecraft.label.body.4"), width / 2 - 170, (height / 4 - 60) + 60 + 45, 0xdedede);
+        drawString(font, i.translateKey("gui.no_minecraft.label.body.5"), width / 2 - 170, (height / 4 - 60) + 60 + 54, 0xdedede);
+        super.render(xm, ym, partialTick);
     }
     @Override
-    protected void buttonPressed(GuiButton button)
+    protected void buttonClicked(ButtonElement button)
     {
         if(!button.enabled)
         {
@@ -56,13 +59,13 @@ public class GuiMissingMinecraft extends GuiScreen{
                 }
                 catch (Exception e)
                 {
-                    e.printStackTrace();
+                    LOGGER.error("Exception occurred when attempting to open URL 'https://www.betterthanadventure.net/installation-guide/'!", e);
                 }
             } else if (button.id == 2) {
                 try {
                     desktop.browse(URI.create("https://betterthanadventure.net/discord"));
                 } catch (Exception e){
-                    e.printStackTrace();
+                    LOGGER.error("Exception occurred when attempting to open URL 'https://betterthanadventure.net/discord'!", e);
                 }
             }
         }
@@ -78,7 +81,7 @@ public class GuiMissingMinecraft extends GuiScreen{
         GL11.glDisable(GL11.GL_FOG);
 
         Tessellator tessellator = Tessellator.instance;
-        mc.renderEngine.loadTexture("/assets/minecraft/textures/block/netherrack_mossy.png").bind();
+        mc.textureManager.loadTexture("/assets/minecraft/textures/block/netherrack_mossy.png").bind();
         GL11.glColor4f(1.0F, 1.0F, 1.0F, 1.0F);
         GL11.glEnable(GL11.GL_BLEND);
 
@@ -92,7 +95,7 @@ public class GuiMissingMinecraft extends GuiScreen{
         tessellator.addVertexWithUV(0.0D, 0.0D, 0.0D, 0.0D, 0);
         tessellator.draw();
 
-        mc.renderEngine.loadTexture("/assets/minecraft/textures/block/dirt.png").bind();
+        mc.textureManager.loadTexture("/assets/minecraft/textures/block/dirt.png").bind();
         GL11.glColor4f(1.0F, 1.0F, 1.0F, 1.0f);
 
         // Then Draw dirt texture
diff --git a/src/main/java/net/minecraft/client/gui/GuiPickMonster.java b/src/main/java/net/minecraft/client/gui/MobPickerScreen.java
similarity index 90%
rename from src/main/java/net/minecraft/client/gui/GuiPickMonster.java
rename to src/main/java/net/minecraft/client/gui/MobPickerScreen.java
index 807b4c278..e7090be26 100644
--- a/src/main/java/net/minecraft/client/gui/GuiPickMonster.java
+++ b/src/main/java/net/minecraft/client/gui/MobPickerScreen.java
@@ -1,6 +1,6 @@
 package net.minecraft.client.gui;
 
-import net.minecraft.client.gui.popup.GuiPopup;
+import net.minecraft.client.gui.popup.PopupScreen;
 import net.minecraft.client.gui.popup.PopupBuilder;
 import net.minecraft.core.block.entity.MobSpawnerBlockEntity;
 import net.minecraft.core.entity.Entity;
@@ -14,8 +14,8 @@ import java.util.ArrayList;
 import java.util.Collections;
 import java.util.List;
 
-public class GuiPickMonster
-    extends GuiScreen {
+public class MobPickerScreen
+    extends Screen {
     private final int x;
     private final int y;
     private final int z;
@@ -23,7 +23,7 @@ public class GuiPickMonster
     private boolean shouldClose = false;
 
 
-    public GuiPickMonster(String mobId, int x, int y, int z) {
+    public MobPickerScreen(String mobId, int x, int y, int z) {
         this.mobId = mobId;
         this.x = x;
         this.y = y;
@@ -52,7 +52,7 @@ public class GuiPickMonster
             prettyMonsters.add(sb.toString());
         }
 
-        GuiPopup popup = new PopupBuilder(this, 150)
+        PopupScreen popup = new PopupBuilder(this, 150)
             .withLabel("gui.pick_monster.label.title")
             .withList("list", 140, prettyMonsters.toArray(new String[0]), null, -1, true)
             .closeOnEsc(0)
@@ -73,14 +73,14 @@ public class GuiPickMonster
                 shouldClose = true;
             })
             .build();
-        mc.displayGuiScreen(popup);
+        mc.displayScreen(popup);
     }
 
     @Override
     public void tick() {
         super.tick();
         if (shouldClose) {
-            mc.displayGuiScreen(null);
+            mc.displayScreen(null);
         }
     }
 
diff --git a/src/main/java/net/minecraft/client/gui/OutOfMemoryScreen.java b/src/main/java/net/minecraft/client/gui/OutOfMemoryScreen.java
new file mode 100644
index 000000000..480703a70
--- /dev/null
+++ b/src/main/java/net/minecraft/client/gui/OutOfMemoryScreen.java
@@ -0,0 +1,29 @@
+package net.minecraft.client.gui;
+
+
+// Referenced classes of package net.minecraft.src:
+//            GuiScreen, GuiButton
+
+import net.minecraft.core.lang.I18n;
+
+public class OutOfMemoryScreen extends Screen
+{
+    @Override
+    public void keyPressed(char eventCharacter, int eventKey, int mx, int my) {
+    }
+
+    @Override
+	public void render(int xm, int ym, float partialTick)
+    {
+        I18n i18n = I18n.getInstance();
+        renderBackground();
+        drawStringCentered(font, i18n.translateKey("gui.out_of_memory.label.title"), width / 2, (height / 4 - 60) + 20, 0xFFFFFF);
+        drawString(font, i18n.translateKey("gui.out_of_memory.label.body.1"), width / 2 - 140, (height / 4 - 60) + 60 + 0, 0xA0A0A0);
+        drawString(font, i18n.translateKey("gui.out_of_memory.label.body.2"), width / 2 - 140, (height / 4 - 60) + 60 + 18, 0xA0A0A0);
+        drawString(font, i18n.translateKey("gui.out_of_memory.label.body.3"), width / 2 - 140, (height / 4 - 60) + 60 + 27, 0xA0A0A0);
+        drawString(font, i18n.translateKey("gui.out_of_memory.label.body.4"), width / 2 - 140, (height / 4 - 60) + 60 + 36, 0xA0A0A0);
+        drawString(font, i18n.translateKey("gui.out_of_memory.label.body.5"), width / 2 - 140, (height / 4 - 60) + 60 + 45, 0xA0A0A0);
+        drawString(font, i18n.translateKey("gui.out_of_memory.label.body.6"), width / 2 - 140, (height / 4 - 60) + 60 + 63, 0xA0A0A0);
+        super.render(xm, ym, partialTick);
+    }
+}
